﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Drawing;
using Microsoft.DirectX.DirectInput;
using Microsoft.DirectX;

#endregion

using System.Windows.Forms;

namespace StarTrooper
{
  public class Trooper: Sprite
  {
    public override void Update()
    {
      //Type the code here to add the Trooper movement.
      #region TrooperMovement_code
      int vx = 0, vy = 0;
      if (Position.Y > 50 && Keyboard.IsPressed(Key.UpArrow))
        vy = -2;
      if (Position.Y < 450 && Keyboard.IsPressed(Key.DownArrow))
        vy = 2;
      if (Position.X > 30 && Keyboard.IsPressed(Key.LeftArrow))
      {
        vx = -2;
        ScaleX = -1;
      }
      if (Position.X < 610 && Keyboard.IsPressed(Key.RightArrow))
      {
        vx = 2;
        ScaleX = 1;
      }

      Velocity = new Vector2(vx, vy);
      if (Keyboard.IsTriggered(Key.Space))
      {
        Fire fire = (Fire)StarTrooper.Fire.Clone();
        fire.Position = new PointF(Position.X, Position.Y - 35);
        fire.Velocity = new Vector2(0, -4);
        Game.Add(fire);
      }
      #endregion
    }
    static int m_Shots;
  }

  public class Condor : Sprite
  {
    public Condor()
    {
    }

    protected Condor(Condor condor): base(condor)
    {
    }

    public override Object Clone()
    {
      return new Condor(this);
    }

    public override void Update()
    {
      Trooper b = StarTrooper.Trooper;
      Vector2 v = new Vector2(b.Position.X - Position.X, b.Position.Y - Position.Y);
      v.Normalize();

      Velocity = v;

      if (v.X >= 0)
        ScaleX = 1;
      else
        ScaleX = -1;
    }
  }

  #region Fire Class
  public class Fire : Sprite
  {
    public Fire()
    {
    }

    protected Fire(Fire fire): base(fire)
    {
    }

    public override Object Clone()
    {
      return new Fire(this);
    }

    public override void Update()
    {
      float y = Position.Y;
      ScaleX = ScaleY = 1 + Math.Abs(0.001f *(480 - Position.Y));
    }
  }
  #endregion
}
